#include "afflib.h"
#include <openssl/md5.h>
#include <openssl/sha.h>


class imager {
public:
    aff_ull total_sectors_written ;
    aff_ull total_sectors_read;
    aff_ull total_bytes_read;
    aff_ull total_bytes_written;
    aff_ull total_blank_sectors;

    bool	imaging;

    /* Device parameters */
    int		in;			// input fd
    int		sector_size;		// in bytes; 0 if unknown
    aff_ull total_sectors;	      // in sectors; 0 if uncomputable
    int		maxreadblocks;		// in bytes

    AFFILE *af;				// AF output file
    FILE *fout;				// STDIO output file

    /* For calculating hashes */
    MD5_CTX md5;			// for the image
    SHA_CTX sha;			// for the image
    bool hash_invalid;			// did we reverse direction or skip?


    aff_ull last_sector_read ;	// sector number last read
    int		last_sectors_read;

    /* Configuration */
    bool seek_on_output;		// if True, then we need to recalculate md5 & sha
    int  retry_count;

    imager();
    void (*status)();
    void image_loop(aff_ull low_water_mark,
			aff_ull high_water_mark,
			int direction, int readsectors,int error_mask);
    int set_input(int ifd);
    void set_fout(FILE *fout);
    void write_data(unsigned char *buf,aff_ull offset,int bytes_read);
    void set_af(AFFILE *af);
    void hash_setup();
    float compression_ratio();

    /* Error handling */
    aff_ull bad_sectors_read;
    int errors_in_a_row;
    int error_recovery_phase;
    int last_direction;			// 1 = forwards, -1 = backwards
};


